/* This program initializes the Serial Ports*/
#include <Cdef21369.h>
#include <def21369.h>
#include <21369.h>
#include "cogging.h"
#include "mfctest_c.h"



void initSPORT(void)
	{

    unsigned int usreg1, usreg2;
    
/* Configure SPORT1 (Front Panel) as a transmitter */
*pSPCTL3 = 0;
*pSPCTL4 = 0;
*pSPCTL1 = 0;

/* internally generating clock and frame sync */
/* CLKDIV = [fCCLK(333MHz)/2 x FSCLK(8.325 MHz)]  1 = 0x0004 */
/* FSDIV = [FSCLK(8.325 MHz)/TFS(.26 MHz)]  1 = 31 = 0x001F */
usreg1 = 0x001F0000;
*pDIV1 = usreg1;
*pDIV4 = usreg1;
*pDIV3 = usreg1;

usreg2 = 		SPEN_A| /* Enable Channel A */
				SPEN_B|		// Enable Channel B 
				FS_BOTH|	// Assert FrameSync when data is present in 
							// both TXA & TXB buffers 
				SLEN32|		// 32-bit word length 
				FSR|		// Frame Sync Required 
				SPTRAN|		// Transmit on enabled channels 
				BHD|		// Ignore core hang
				IFS|		// Internally Generated Frame Sync
				ICLK;		// Internally Generated Clock
				
// *pSPCTL3 = usreg2;
// *pSPCTL4 = usreg2;
// *pSPCTL1 = usreg2;

	} //initSPORT.end:

