.file_attr libGroup="startup";
.file_attr libName="libc";
.file_attr libFunc="___lib_prog_term";
.file_attr FuncName="___lib_prog_term";
.file_attr prefersMem="any";
.file_attr prefersMemNum="50";

#include <def21369.h>

.extern ___lib_int_table;
.extern _main;
.extern IRQ0_Service_Routine, Data_Acquire;

.GLOBAL  ___lib_prog_term;           
.GLOBAL  __done_execution;
.EXTERN  ___lib_setup_c;

.SEGMENT/PM   seg_rth;      

               NOP;
               NOP;
               NOP;
               NOP;

___lib_RSTI:   NOP;                    
               JUMP ___lib_start;
               NOP;
               NOP;

___lib_IICDI:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(2*6);    
              
___lib_SOVFI:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(3*6);
                   
___lib_TMZHI:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(4*6);

___lib_SPERRI: push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(5*6);

___lib_BKPI:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(6*6);

               NOP;
               NOP;
               NOP;
               NOP;
       
___lib_IRQ2I:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(8*6);

___lib_IRQ1I:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(9*6);

___lib_IRQ0I:  bit set mode1 SRCU|SRD1H|SRD2H|SRD1L|SRD2L|SRRFH|SRRFL; // switch context to secondary registers  
               nop;                                                    // 1 cycle effect latency		
               jump IRQ0_Service_Routine;
               nop;

___lib_P0I:    push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(11*6);

___lib_P1I:    push sts;
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(12*6);        

___lib_P2I:    push sts; 
               JUMP ___z3_int_determiner(DB);
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(13*6);        

___lib_P3I:    push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(14*6);

___lib_P4I:    push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(15*6);        

___lib_P5I:    push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(16*6);

___lib_P6I:    push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(17*6);

___lib_P7I:    push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(18*6);

___lib_P8I:    push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(19*6);

___lib_P9I:    push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(20*6);

___lib_P10I:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(21*6);       

___lib_P11I:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(22*6);      

___lib_P12I:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(23*6);

___lib_P13I:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(24*6);

___lib_P14I:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(25*6);

___lib_P15I:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(26*6);

___lib_P16I:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(27*6);       

___lib_P17I:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(28*6);     

___lib_P18I:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(29*6);

___lib_CB7I:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(30*6);       

___lib_CB15I:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(31*6);    

___lib_TMZLI:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(32*6);

___lib_FIXI:   push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(33*6);      

___lib_FLTOI:  push sts;
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(34*6);     

___lib_FLTUI:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(35*6);

___lib_FLTII:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(36*6);      

___lib_EMULI:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(37*6);      

___lib_SFT0I:  push sts;	//Make sure to pop sts before returning from Int Service routine to switch back to previous context					
               bit set mode1 SRCU|SRD1H|SRD2H|SRD1L|SRD2L|SRRFH|SRRFL; // switch context to secondary registers  
               nop;                                                    // 1 cycle effect latency		
               jump Data_Acquire;
___lib_SFT1I:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(39*6);

___lib_SFT2I:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(40*6);

___lib_SFT3I:  push sts; 
               JUMP ___z3_int_determiner(DB); 
               DM(I7,M7)=R2; 
               R2=___lib_int_table+(41*6);

               NOP;
               NOP;
               NOP;
               NOP;
            
___z3_int_determiner:    
            DM(I7,M7)=R1;                    
            R1=I2;
            DM(I7,M7)=R1;            
            I2=R2;
            DM(I7,M7)=I13;           
            I13=DM(5,I2);            
            JUMP (M13, I13) (DB);    
            NOP;                     
            I13=DM(2,I2);            

___lib_start:        
            CALL ___lib_setup_c;     

JUMP _main;                    

.___lib_start.end:

 ___lib_prog_term:    
            PM(__done_execution)=PC;
            IDLE;
            JUMP ___lib_prog_term;         
.___lib_prog_term.end:

.VAR __done_execution = 0;

.ENDSEG;
